//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbwxDropFiles.h"
#include "bbwxPackage.h"

#include "bbtkWx.h"
#include <wx/dnd.h>

namespace bbwx
{


class WxDropFiles: public wxFileDropTarget
{
public:
 	WxDropFiles(DropFiles *box): mbox(box){}
    bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& arrFilenames);
private:
	DropFiles *mbox;
};

bool WxDropFiles::OnDropFiles(wxCoord WXUNUSED(x), wxCoord WXUNUSED(y), const wxArrayString& arrFilenames)
{
	std::vector<std::string> tmpLst;
	int i,sizeArrFilenames=arrFilenames.GetCount();
	for( i=0 ; i<sizeArrFilenames ; i++ )
	{
		std::string ss=bbtk::wx2std( arrFilenames.Item(i) );
		tmpLst.push_back( bbtk::wx2std( arrFilenames.Item(i) )  );
	}

	mbox->bbSetOutputLstPaths( tmpLst );
	mbox->bbSignalOutputModification(  );
    return true;
}


BBTK_ADD_BLACK_BOX_TO_PACKAGE(wx,DropFiles)
BBTK_BLACK_BOX_IMPLEMENTATION(DropFiles,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void DropFiles::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;

	if (bbGetInputWidget()!=NULL)
	{ 
		bbGetInputWidget()->SetDropTarget( new WxDropFiles(this) );
	}
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void DropFiles::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputWidget(NULL);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void DropFiles::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void DropFiles::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbwx


