/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbstdStringWriter.h"
#include "bbstdPackage.h"

namespace bbstd
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(std,StringWriter)
BBTK_BLACK_BOX_IMPLEMENTATION(StringWriter,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StringWriter::Process()
{

	if (bbGetInputFileName()!="")
	{
		FILE *ff = fopen(bbGetInputFileName().c_str(),"w");
		if (ff!=NULL)
		{
			if (bbGetInputIn0()!="") { fprintf(ff,"%s\n",bbGetInputIn0().c_str()); }
			if (bbGetInputIn1()!="") { fprintf(ff,"%s\n",bbGetInputIn1().c_str()); }
			if (bbGetInputIn2()!="") { fprintf(ff,"%s\n",bbGetInputIn2().c_str()); }
			if (bbGetInputIn3()!="") { fprintf(ff,"%s\n",bbGetInputIn3().c_str()); }
			if (bbGetInputIn4()!="") { fprintf(ff,"%s\n",bbGetInputIn4().c_str()); }
			if (bbGetInputIn5()!="") { fprintf(ff,"%s\n",bbGetInputIn5().c_str()); }
			if (bbGetInputIn6()!="") { fprintf(ff,"%s\n",bbGetInputIn6().c_str()); }
			if (bbGetInputIn7()!="") { fprintf(ff,"%s\n",bbGetInputIn7().c_str()); }
			if (bbGetInputIn8()!="") { fprintf(ff,"%s\n",bbGetInputIn8().c_str()); }
			if (bbGetInputIn9()!="") { fprintf(ff,"%s\n",bbGetInputIn9().c_str()); }
			fclose(ff);
		}
	}
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StringWriter::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
	bbSetInputIn0("");
	bbSetInputIn1("");
	bbSetInputIn2("");
	bbSetInputIn3("");
	bbSetInputIn4("");
	bbSetInputIn5("");
	bbSetInputIn6("");
	bbSetInputIn7("");
	bbSetInputIn8("");
	bbSetInputIn9("");
	bbSetInputFileName("");
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StringWriter::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StringWriter::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbstd


